var _inputField=null; // le champ texte lui-même
var _submitButton=null; // le bouton suivant de notre formulaire
var _addrComplete=null;//adress of the XML options
//tableau des formulaires observés :
var _docField = new Array();
var _nbField = 0;
var _oldInputFieldValue=""; // valeur précédente du champ texte
var _currentInputFieldValue=""; // valeur actuelle du champ texte
var _resultCache=new Object(); // mécanisme de cache des requetes
var _ac_init_done=false;

function process_keypress(event) {
	var keynum;
	if(window.event){
		keynum = event.keyCode;
	} else if(event.which) {
		keynum = event.which;
	}
	if ( event.type == "keypress" & keynum == 13) {
		hideCompleteDiv();
		if( _submitButton )
			_submitButton.focus();
		return false;
	}
	return true;
}
function startAutoComplete() {
	//this must be called in body.onLoad
	if ( _ac_init_done == false) {
		cacheResults("",new Array());
		creeAutocompletionDiv();
		setTimeout("mainLoop()",200);
		_ac_init_done = true;
	}
}
function initAutoComplete(fieldId,nextId, addr){
	_docField[_nbField] = new Array();
	_docField[_nbField]['field'] = document.getElementById(fieldId);
	if ( nextId ) {
		_docField[_nbField]['next'] = document.getElementById(nextId);
	} else {
		_docField[_nbField]['next'] = null;
	}
	_docField[_nbField]['addr'] = addr;

	_inputField=_docField[_nbField]['field'];
	_submitButton=_docField[_nbField]['next'];

	if ( _inputField ) {
		_inputField.autocomplete="off";
		_currentInputFieldValue=_inputField.value;
		_inputField.onkeyup=onKeyUpHandler;
		_inputField.onblur=onBlurHandler;
		_inputField.onkeydown=onKeyDownHandler;
		_inputField.onkeypress = process_keypress;
	}
	_oldInputFieldValue=_currentInputFieldValue;
	_nbField++;
}

// tourne en permanence pour suggerer suite à un changement du champ texte
function mainLoop(){
	if(_oldInputFieldValue!=_currentInputFieldValue){
		var valeur=escapeURI(_currentInputFieldValue);
		var suggestions=_resultCache[_currentInputFieldValue];
		if(suggestions){ // la réponse était encore dans le cache
			metsEnPlace(valeur,suggestions);
		}else{
			callSuggestions(valeur); // appel distant
		}
		_inputField.focus();
	}
	_oldInputFieldValue=_currentInputFieldValue;
	setTimeout("mainLoop()",200); // la fonction se redéclenchera dans 200 ms
	return true;
}

// echappe les caractère spéciaux
function escapeURI(La){
	if(encodeURIComponent) {
		return encodeURIComponent(La);
	}
	if(escape) {
		return escape(La);
	}
}

var _xmlHttp = null; //l objet xmlHttpRequest utilisé pour contacter le serveur
function completeCallback() {
	if(_xmlHttp.readyState==4&&_xmlHttp.responseXML) {
		var valeur = traiteXmlSuggestionsQuery(_xmlHttp.responseXML);
		var liste = traiteXmlSuggestions(_xmlHttp.responseXML);
		cacheResults(valeur,liste);
		metsEnPlace(valeur,liste);
	}
}

function callSuggestions(valeur){
	if( _xmlHttp && _xmlHttp.readyState!=0){
		_xmlHttp.abort();
	}
	_xmlHttp=CreateXmlHttpReq(completeCallback);
	if( _xmlHttp && _addrComplete ){
		XmlHttpGET(_xmlHttp,_addrComplete+','+valeur+'.xml');
	}
}
function cacheResults(debut,suggestions){
	_resultCache[debut]=suggestions;
}
function traiteXmlSuggestions(xmlDoc) {
	var options = xmlDoc.getElementsByTagName('option');
	var optionsListe = new Array();
	for (var i=0; i < options.length; ++i) {
		optionsListe.push(options[i].firstChild.data);
	}
	return optionsListe;
}
function traiteXmlSuggestionsQuery(xmlDoc) {
	return xmlDoc.getElementsByTagName('options').item(0).getAttribute('query');
}
function calculateOffset(r,attr){
	var kb=0;
	while(r){
		kb+=r[attr];
		r=r.offsetParent;
	}
	return kb;
}
function setCompleteDivSize(){
	if(_completeDiv && _inputField ){
		_completeDiv.style.left=calculateOffset(_inputField,"offsetLeft")+"px";
		_completeDiv.style.top=calculateOffset(_inputField,"offsetTop")+_inputField.offsetHeight-1+"px";
		_completeDiv.style.width = (_inputField.offsetWidth-2)+"px";
	}
}

function creeAutocompletionDiv() {
	_completeDiv=document.createElement("div");
	_completeDiv.id="completeDiv";
	setCompleteDivSize();
	document.body.appendChild(_completeDiv);
}

function metsEnPlace(valeur, liste){
	while(_completeDiv.childNodes.length>0) {
		_completeDiv.removeChild(_completeDiv.childNodes[0]);
	}
	// mise en place des suggestions
	for(var f=0; f<liste.length; ++f){
		var nouveauDiv=document.createElement("div");
		nouveauDiv.onmousedown=divOnMouseDown;
		nouveauDiv.onmouseover=divOnMouseOver;
		nouveauDiv.className = "AutoCompleteDiv";
		var nouveauSpan=document.createElement("span");
		nouveauSpan.innerHTML=liste[f]; // le texte de la suggestion
		nouveauDiv.appendChild(nouveauSpan);
		_completeDiv.appendChild(nouveauDiv);
	}
	PressAction();
	if(_completeDivRows>0) {
		_completeDiv.height=16*_completeDivRows+4;
	} else {
		hideCompleteDiv();
	}
}

var _lastKeyCode=null;

// Handler pour le keydown du document
var onKeyDownHandler=function(event){
	// accès evenement compatible IE/Firefox
	if(!event&&window.event) {
		event=window.event;
	}
	// on enregistre la touche ayant déclenché l'evenement
	if(event) {
		_lastKeyCode=event.keyCode;
	}
}

var _eventKeycode = null;

// Handler pour le keyup de lu champ texte
var onKeyUpHandler=function(event){
	// accès evenement compatible IE/Firefox
	if(!event&&window.event) {
		event=window.event;
	}
	_inputField = this;
	for( var i=0; i<_nbField; i++) {
		if ( _docField[i]['field'] == this ) {
			_submitButton = _docField[i]['next'];
			_addrComplete = _docField[i]['addr'];
		}
	}
	_eventKeycode=event.keyCode;
	// Dans les cas touches touche haute(38) ou touche basse (40)
	if(_eventKeycode==40||_eventKeycode==38) {
		// on autorise le blur du champ (traitement dans onblur)
		blurThenGetFocus();
	}
	// contenu du champ texte
	var V=_inputField.value;
	if(_eventKeycode!=0){
		if(_eventKeycode==13||_eventKeycode==3){
			var d=_inputField;
			// on mets en place l'ensemble du champ texte en repoussant la selection
			if(_inputField.createTextRange){
				var t=_inputField.createTextRange();
				t.moveStart("character",_inputField.value.length);
				_inputField.select();
			} else if (d.setSelectionRange){
				_inputField.setSelectionRange(_inputField.value.length,_inputField.value.length);
			}
		} else {
			if(_inputField.value!=V) {
				_inputField.value=V;
			}
		}
	}
	// si la touche n'est ni haut, ni bas, on stocke la valeur utilisateur du champ
	if(_eventKeycode!=40&&_eventKeycode!=38) {
		// le champ courant n est pas change si key Up ou key Down
		_currentInputFieldValue=V;
	}
	if(handleCursorUpDownEnter(_eventKeycode)&&_eventKeycode!=0) {
		// si on a pressé une touche autre que haut/bas/enter
		PressAction();
	}
}

// Change la suggestion selectionné.
// cette méthode traite les touches haut, bas et enter
function handleCursorUpDownEnter(eventCode){
	if(eventCode==40){
		highlightNewValue(_highlightedSuggestionIndex+1);
		return false;
	}else if(eventCode==38){
		highlightNewValue(_highlightedSuggestionIndex-1);
		return false;
	}else if(eventCode==13||eventCode==3){
		return false;
	}
	return true;
}

var _completeDivRows = 0;
var _completeDivDivList = null;
var _highlightedSuggestionIndex = -1;
var _highlightedSuggestionDiv = null;

// gère une touche pressée autre que haut/bas/enter
function PressAction(){
	_highlightedSuggestionIndex=-1;
	var suggestionList=_completeDiv.getElementsByTagName("div");
	var suggestionLongueur=suggestionList.length;
	// on stocke les valeurs précédentes
	// nombre de possibilités de complétion
	_completeDivRows=suggestionLongueur;
	// possiblités de complétion
	_completeDivDivList=suggestionList;
	// si le champ est vide, on cache les propositions de complétion
	if(_currentInputFieldValue==""||suggestionLongueur==0){
		hideCompleteDiv();
	}else{
		showCompleteDiv();
	}
	var trouve=false;
	// si on a du texte sur lequel travailler
	if(_currentInputFieldValue.length>0){
		var indice;
		// T vaut true si on a dans la liste de suggestions un mot commencant comme l'entrée utilisateur
		for(indice=0; indice<suggestionLongueur; indice++){
			if(getSuggestion(suggestionList.item(indice)).toUpperCase().indexOf(_currentInputFieldValue.toUpperCase())==0) {
				trouve=true;
				break;
			}
		}
	}
	// on désélectionne toutes les suggestions
	for(var i=0; i<suggestionLongueur; i++) {
		suggestionList.item(i).className = "AutoCompleteDiv";
	}
	// si l'entrée utilisateur (n) est le début d'une suggestion (n-1) on sélectionne cette suggestion avant de continuer
	if(trouve){
		_highlightedSuggestionIndex=indice;
		_highlightedSuggestionDiv=suggestionList.item(_highlightedSuggestionIndex);
	}else{
		_highlightedSuggestionIndex=-1;
		_highlightedSuggestionDiv=null;
	}
	var supprSelection=false;
	switch(_eventKeycode){
		// cursor left, cursor right, page up, page down, others??
		case 8:
		case 33:
		case 34:
		case 35:
		case 35:
		case 36:
		case 37:
		case 39:
		case 45:
		case 46:
			// on supprime la suggestion du texte utilisateur
			supprSelection=true;
			break;
		default:
			break;
	}
	// si on a une suggestion (n-1) sélectionnée
	if(!supprSelection&&_highlightedSuggestionDiv){
		_highlightedSuggestionDiv.className = "AutoCompleteDivAct";
		var z;
		if(trouve) {
			z=getSuggestion(_highlightedSuggestionDiv).substr(0);
		} else {
			z=_currentInputFieldValue;
		}
		if(z!=_inputField.value){
			if(_inputField.value!=_currentInputFieldValue) {
				return;
			}
			// si on peut créer des range dans le document
			if(_inputField.createTextRange||_inputField.setSelectionRange) {
				_inputField.value=z;
			}
			// on sélectionne la fin de la suggestion
			if(_inputField.createTextRange){
				var t=_inputField.createTextRange();
				t.moveStart("character",_currentInputFieldValue.length);
				t.select();
			} else if(_inputField.setSelectionRange){
				_inputField.setSelectionRange(_currentInputFieldValue.length,_inputField.value.length);
			}
		}
	}else{
		// sinon, plus aucune suggestion de sélectionnée
		_highlightedSuggestionIndex=-1;
	}
}

var _cursorUpDownPressed = null;

// permet le blur du champ texte après que la touche haut/bas ai été pressé.
// le focus est récupéré après traitement (via le timeout).
function blurThenGetFocus(){
	_cursorUpDownPressed=true;
	if ( _inputField ) {
		_inputField.blur();
	}
	setTimeout("_inputField.focus()",10);
	return;
}

// Place le curseur à la fin du champ
function cursorAfterValue(n){
	if(n.createTextRange){
		var t=n.createTextRange();
		t.moveStart("character",n.value.length);
		t.select();
	} else if(n.setSelectionRange) {
		n.setSelectionRange(n.value.length,n.value.length);
	}
}
function html_entity_decode(str) {
var tarea=document.createElement('textarea');
tarea.innerHTML = str; return tarea.value;
tarea.parentNode.removeChild(tarea);
}
// Retourne la valeur de la possibilite (texte) contenu dans une div de possibilite
function getSuggestion(uneDiv){
	if(!uneDiv) {
		return null;
	}
	return html_entity_decode(trimCR(uneDiv.getElementsByTagName('span')[0].innerHTML));
}

// supprime les caractères retour chariot et line feed d'une chaine de caractères
function trimCR(chaine){
	var nChaine = "";
	var insideTag = false;
	if(chaine) {
		for(var f=0,zb="\n\r"; f<chaine.length; f++) {
			if (zb.indexOf(chaine.charAt(f))==-1) {
				if ( chaine.charAt(f) != '<' && insideTag == false ) {
					nChaine+=chaine.charAt(f);
				} else if ( chaine.charAt(f) == '>' ) {
					insideTag = false;
				} else {
					insideTag = true;
				}
			}
		}
	}
	return nChaine;
}

// Cache completement les choix de completion
function hideCompleteDiv(){
	_completeDiv.style.visibility="hidden";
}

// Rends les choix de completion visibles
function showCompleteDiv(){
	_completeDiv.style.visibility="visible";
	setCompleteDivSize();
}

// Change la suggestion en surbrillance
function highlightNewValue(C){
	if(!_completeDivDivList||_completeDivRows<=0) {
		return;
	}
	showCompleteDiv();
	if(C>=_completeDivRows){
		C=_completeDivRows-1;
	}
	if(_highlightedSuggestionIndex!=-1&&C!=_highlightedSuggestionIndex){
		_highlightedSuggestionDiv.className = "AutoCompleteDiv";
		_highlightedSuggestionIndex=-1;
	}
	if(C<0){
		_highlightedSuggestionIndex=-1;
		_inputField.focus();
		return;
	}
	_highlightedSuggestionIndex=C;
	_highlightedSuggestionDiv=_completeDivDivList.item(C);
	_highlightedSuggestionDiv.className = "AutoCompleteDivAct";
	_inputField.value=getSuggestion(_highlightedSuggestionDiv);
}

// Handler de blur sur le champ texte
var onBlurHandler=function(event){
	if(!_cursorUpDownPressed){
		// si le blur n est pas causé par la touche haut/bas
		hideCompleteDiv();
		// Si la dernière touche pressé est tab, on passe au bouton de validation
		if(_lastKeyCode==9){
			if( _submitButton )
				_submitButton.focus();
			_lastKeyCode=-1;
		}
	}
	_cursorUpDownPressed=false;
};

// declenchee quand on clique sur une div contenant une possibilite
var divOnMouseDown=function(){
	_inputField.value=getSuggestion(this);
};
// declenchee quand on passe sur une div de possibilite. La div précédente est passee en style normal
function divOnMouseOver(){
	if(_highlightedSuggestionDiv) {
		_highlightedSuggestionDiv.className = "AutoCompleteDiv";
	}
	for(var i=0; i<_completeDivDivList.length; i++ ) {
		if ( _completeDivDivList.item(i) == this ) {
			_highlightedSuggestionIndex=i;
			_highlightedSuggestionDiv=this;
			break;
		}
	}
	this.className = "AutoCompleteDivAct";
}
